var comparisonResults;

function showDetails() {
    var org_row = $(this);
    org_row.off('click', showDetails);
    var id = org_row.data("id");
    var compare_result = comparisonResults.Comparison[id];
    var new_table = $('<table>')
    if (compare_result.Name == "Screenshots") {
        new_table.append($('<tr>')
                .append($('<td class="screenshot">')
                    .append($('<img src=comparison.png>')))) // FIXME: magic string
    } else {
        new_table.append($('<tr>')
                .append($('<th>').append("Snapshot"))
                .append($('<th>').append("Prerelease")))
        new_table.append($('<tr>')
                .append($('<td class="snap stdout">')
                    .append($('<pre>').append(compare_result.Snapshot.Stdout)))
                .append($('<td class="pre stdout">')
                    .append($('<pre>').append(compare_result.Prerelease.Stdout))));
    }
    var new_row = $('<tr>').append($('<td colspan="2">').append(new_table));
    org_row.after(new_row);

    var collapse = function () {
        new_row.remove();
        org_row.unbind('click', collapse);
        org_row.on('click', showDetails);
    }
    org_row.click(collapse); // FIXME: doesn't work
    new_row.click(collapse);
}

function showMainResults(data) {
    comparisonResults = data;
    for (i in data.Comparison) {
        var row = data.Comparison[i];
        var table_row = $('<tr>')
                .append($('<td class="name">').append(row.Name))
                .append($('<td class="result">').append(row.Result))
                .data("id", i)
                .click(showDetails);
        $('#all').append(table_row);
    }
}

function init() {
    $.ajax({
        method: "GET",
        url: "comparison.json",
        contentType: "application/json",
        success: showMainResults
    })
}

window.onload = init
